#!/usr/bin/perl
#=======================================================
#           INSTALL ROUTINE FOR "RADMC"
#=======================================================
$pwd  = `pwd` ; 
chop($pwd) ;
print "Installing RADMC in the directory:\n  '$pwd'\n";
$home = $ENV{"HOME"};
$bin  = $home . "/.system/bin" ;
if(!(-e $bin)) {
    $bin  = $home . "/bin" ;
}
if(!(-e $bin)) {
    print "You must have a bin/ directory in your home directory\n" ;
    print "-----Shall I make $bin for you?\n" ;
    $input = <STDIN> ;
    print $input ;
    if($input=~/^[yY]/) {
	print "Creating $bin for you...\n" ;
	system("mkdir $bin") ;
    }
}
$path = $ENV{"PATH"};
if(!($path =~ /$bin/)) {
    print "The $bin directory exists, but it not in the PATH environment variable\n" ;
    print "You must put the \n" ;
    print "$bin directory \n" ;
    print "in the path yourself (in the .tcshrc file or so...)\n" ;
    print "If you do it now, don't forget to type 'rehash'.\n" ;
}
#
# Creating the automatic link for the executable
#
print "  Creating a link 'radmc' in '$bin/'\n" ;
$radmc    = $pwd . "/radmc" ;
$radmclnk = $bin . "/radmc" ;
if(!(-e $radmclnk)) {
    print "------ Warning: file $radmclnk did not exist previously. You might want to type 'rehash'\n" ;
}
open(FILE,">$radmclnk") || die "Could not open log file\n" ;
print FILE "#!/usr/bin/perl\n" ;
print FILE "system(\"$radmc \@ARGV\");" ;
close (FILE) ;
`chmod u+rwx $radmclnk` ;
